function initGuiBox(width, height, x, y)

	local box = MOAIProp2D.new ()

	box.dna = {}

	box.blackBg = MOAIGfxQuad2D.new ()
	box.blackBg:setTexture ( "img/blackbg.png" )
	box.blackBg:setRect ( 0, 0, width, -height )

	box:setDeck ( box.blackBg )
	box:setLoc ( - 400 + x , 300 - y )

	box.width = width
	box.height = height
	box.lastline = -1
	layer:insertProp (box)

	box.addText = function (box, text, nrline, textsize)
		if (not textsize) then
			textsize = 15
		end

		if (nrline == nil) then
			nrline = box.lastline + 1
		end

		box.lastline = nrline

		local lineheight = textsize + 5

		local txt = MOAITextBox.new ()
		txt:setFont ( font )
		txt:setRect ( 0, 0, box.width - 5*2, lineheight )
		txt:setAlignment ( MOAITextBox.LEFT_JUSTIFY )
		txt:setYFlip ( true )
		txt:setLoc ( 5, -lineheight - nrline* lineheight)
		txt:setString (text )
		txt:setTextSize(textsize)
		txt:setParent(box)
		layer:insertProp (txt)

		return txt
	end

	box.addNum = function (box, text, column, nrline, textsize)
		if (not textsize) then
			textsize = 15
		end

		if (nrline == nil) then
			nrline = box.lastline
		end


		local lineheight = textsize + 5

		text = '<c:74a7fb>' .. text
		local txt = box:addText(text, nrline, textsize)
		if (column) then
			txt:setRect ( 0, 0, column, lineheight )
		end
		txt:setAlignment ( MOAITextBox.RIGHT_JUSTIFY )
		return txt
	end

	box.addDna = function (this, dna)

		dna.prop:setParent(this)
		dna.prop:setLoc(100, -100)

		dna:update()

		local next = #this.dna + 1
		--local next = #this.dna

		this.dna[next] = dna

		if (this.currentDna) then
			this.dna[this.currentDna]:setVisible(false)
		end

		this.currentDna = #this.dna

		return dna
	end


	box.nextDna = function (this)

		if (this.dna[this.currentDna]) then
			this.dna[this.currentDna]:setVisible(false)
		end

		this.currentDna = this.currentDna + 1

		if (not this.dna[this.currentDna]) then
			this.currentDna = 1
		end
		this.dna[this.currentDna]:setVisible(true)

		return this.dna[this.currentDna]
	end

	box.addButton = function (this, text, x, y)

		local bgImg = MOAIGfxQuad2D.new ()
		bgImg:setTexture ( "img/btn.png" )
		bgImg:setRect ( 0, 0, 100, 30 )
		local bgImgHover = MOAIGfxQuad2D.new ()
		bgImgHover:setTexture ( "img/btn-hi.png" )
		bgImgHover:setRect ( 0, 0, 100, 30 )

		local btn = MOAIProp2D.new()
		btn:setDeck ( bgImg )
		btn.image = bgImg
		btn:setParent(this)
		btn:setLoc(x, -y)

		layer:insertProp(btn)


		local txt = MOAITextBox.new ()
		txt:setFont ( font )
		txt:setRect ( 0, 0, 100, 30 )
		txt:setAlignment ( MOAITextBox.CENTER_JUSTIFY )
		txt:setLoc ( 0, -4 )
		txt:setString ('<c:fff>'..text)
		txt:setYFlip ( true )
		txt:setParent(btn)
		txt:setTextSize(15)
		layer:insertProp(txt)

		MOAIInputMgr.hovers[#MOAIInputMgr.hovers + 1] = btn

		btn.txt = txt

		btn.hoverIn = function()
			btn:setDeck(bgImgHover)
		end
		btn.hoverOut = function()
			btn:setDeck(bgImg)
		end

		return btn
	end

	return box
end
