function initSim (species, biome)
	local sim = {}

	sim.species = species
	sim.biome = biome
	sim.nextBiome = nil
	sim.selectedBiome = biome

	sim.ticks = 0
	sim.doTicks = 0
	sim.stepsSinceLastUpdate = 0

	sim.run = true
	sim.speed = 12

	sim.tick = function ()
		while (true)
		do
			while (sim.doTicks > 0)
			do
				sim:nextGen()
				sim.stepsSinceLastUpdate = 0
				sim.doTicks = sim.doTicks - 1
			end
			if (sim.run and sim.speed) then
				sim.stepsSinceLastUpdate = sim.stepsSinceLastUpdate + 1
				if (sim.stepsSinceLastUpdate > sim.speed) then
					sim:nextGen()
					sim.stepsSinceLastUpdate = 0
				end
			end
			coroutine.yield()
		end
	end

	sim.tickThread = MOAICoroutine.new()
	sim.tickThread:run(sim.tick)

	sim.nextGen = function(this)
		sim.species:nextGen()
		sim.species:applyBiome(sim.biome)
		--sim.biome:doEvents()
		if (sim.predator) then
			sim.predator:doPredation(sim.species)
		end
		if (sim.prey) then
			sim.species:doPredation(sim.prey)
		end
		sim.biome:doTick()
		if (sim.nextBiome) then
			sim.nextBiome:doTick()
		end

		-- Update visuals
		sim.species:update()
		sim.selectedBiome:update()
	end

	return sim
end