-- Exit on ESC
function onKeyboardEvent ( key, down )
	if key == 27 and down == false then
		MOAISim.close()
	end

	for k, callback in pairs(keyCallbacks) do
		--print(k, key, down)
		callback(key, down)
	end
end
MOAIInputMgr.device.keyboard:setCallback ( onKeyboardEvent )

-- pointer events

MOAIInputMgr.hovers = {}
MOAIInputMgr.dnaHovers = {}
MOAIInputMgr.clicks = {}

function onPointerEvent ( x, y )
	local guiX, guiY = layer:wndToWorld(MOAIInputMgr.device.pointer:getLoc())
	local dnaX, dnaY = dnaViewLayer:wndToWorld(MOAIInputMgr.device.pointer:getLoc())

	if (false) then
		for p, partition in pairs({partition, dnaPartition}) do
			local hoverX, hoverY
			if (p == 1) then
				hoverX, hoverY = guiX, guiY
			elseif (p == 2) then
				hoverX, hoverY = dnaX, dnaY
			end

			for _, prop in pairs({partition:propListForPoint(hoverX, hoverY)}) do
				for k, hover in pairs(MOAIInputMgr.hovers) do
					if (hover == prop) then
						if (not hover.hover and not hover.newHover) then
							if (hover.hoverIn) then
								hover:hoverIn(hoverX, hoverY)
							end
						else
							if (hover.hoverOver) then
								hover:hoverOver(hoverX, hoverY)
							end
						end
						hover.newHover = true
					end
				end
			end
		end

		for k, hover in pairs(MOAIInputMgr.hovers) do
			if (hover.hover and not hover.newHover) then
				hover.hover = false

				if (hover.hoverOut) then
					hover:hoverOut(hoverX, hoverY)
				end
			end
			hover.newHover = false
		end
	end

	for k, hover in pairs(MOAIInputMgr.hovers) do
		if (hover:inside(guiX, guiY)) then
			if (not hover.hover) then
				if (hover.hoverIn) then
					hover:hoverIn(dnaX, dnaY)
				end
			else
				if (hover.hoverOver) then
					hover:hoverOver(guiX, guiY)
				end
			end
			hover.hover = true
		elseif (hover.hover) then
			hover.hover = false
			if (hover.hoverOut) then
				hover:hoverOut(guiX, guiY)
			end
		end
	end

	for k, hover in pairs(MOAIInputMgr.dnaHovers) do
		if (hover:inside(dnaX, dnaY)) then
			if (not hover.hover) then
				if (hover.hoverIn) then
					hover:hoverIn(dnaX, dnaY)
				end
			else
				if (hover.hoverOver) then
					hover:hoverOver(dnaX, dnaY)
				end
			end
			hover.hover = true
		elseif (hover.hover) then
			hover.hover = false
			if (hover.hoverOut) then
				hover:hoverOut(dnaX, dnaY)
			end
		end
	end

	if dnaViewCamera.drag then

		--local xScale, yScale, _ = layer:getWorldScl()
		local xScale, yScale, _ = dnaViewCamera:getWorldScl()

		if (dnaViewCamera.dragProp == dnaViewCamera) then
			dnaViewCamera.dragProp:addLoc ( (dnaViewCamera.dragStartWinX - x) * xScale, (dnaViewCamera.dragStartWinY - y) * -yScale )
		else
			dnaViewCamera.dragProp:addLoc ( (x - dnaViewCamera.dragStartWinX) * xScale, (y - dnaViewCamera.dragStartWinY) * -yScale )
			sim.species:update()
		end

		if (not dnaViewCamera.dragStartWinX == x  and not y == dnaViewCamera.dragStartWinY) then
			dnaViewCamera.dragged = true
		end

		dnaViewCamera.dragStartWinX, dnaViewCamera.dragStartWinY = x, y
	end
end
MOAIInputMgr.device.pointer:setCallback ( onPointerEvent )

----------------------------------------------------------------
-- mouse left button events

function onMouseLeftEvent ( down )
	--print(dnaViewLayer:wndToWorld(MOAIInputMgr.device.pointer:getLoc()))
	--print(dnaViewLayer:inside(layer:wndToWorld(MOAIInputMgr.device.pointer:getLoc())))
	local guiX, guiY = layer:wndToWorld(MOAIInputMgr.device.pointer:getLoc());

	for k, click in pairs(MOAIInputMgr.clicks) do
		if (click:inside(guiX, guiY)) then
			if (down) then
				click.clickDown = true
			end

			if (down and click.onClickDown) then
				click:onClickDown(guiX, guiY)
			elseif (not down and click.onClickUp and click.clickDown) then
				click:onClickUp(guiX, guiY)
			end
		elseif (click.clickDown) then
			click.clickDown = false
			if (click.onClickCancel) then
				click:onClickCancel(guiX, guiY)
			end
		end
	end

	local dnaLocX, dnaLocY = dnaBackground:wndToWorld(MOAIInputMgr.device.pointer:getLoc())

	if dnaBgProp:inside(dnaLocX, dnaLocY) then

		if down == true then
			local dnaLocX, dnaLocY = dnaViewLayer:wndToWorld(MOAIInputMgr.device.pointer:getLoc())
			dnaViewCamera.dragProp = dnaViewCamera

			for k, dna in pairs(sim.species.dna) do
				if (dna.prop:inside(dnaLocX, dnaLocY)) then
					dnaViewCamera.dragProp = dna.prop
				end
			end

			dnaViewCamera.drag = true
			dnaViewCamera.dragStartWinX, dnaViewCamera.dragStartWinY = MOAIInputMgr.device.pointer:getLoc()
		--print(layer:wndToWorld(MOAIInputMgr.device.pointer:getLoc()))
		else
			dnaViewCamera.drag = false
		end
		return
	end

	if down == false and dnaBgProp:inside(dnaLocX, dnaLocY) and not dnaViewCamera.drag then
		dnaViewCamera.drag = false
		sim.species:select()
	end

	if down == false and speciesNameBox:inside(layer:wndToWorld(MOAIInputMgr.device.pointer:getLoc())) then
		sim.species:select()
	end
end
MOAIInputMgr.device.mouseLeft:setCallback ( onMouseLeftEvent )


-- mouse scroll wheel events
function onMouseWheelEvent ( delta )
	--print (delta)
	if (delta < 0) then
		dnaViewCamera:addScl(0.25)
	elseif (dnaViewCamera:getScl() > 0.25) then
		dnaViewCamera:addScl(-0.25)
	end
end
MOAIInputMgr.device.mouseWheel:setCallback ( onMouseWheelEvent )
